VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsDrawText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Type Rect
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type DRAWTEXTPARAMS
    cbSize As Long
    iTabLength As Long
    iLeftMargin As Long
    iRightMargin As Long
    uiLengthDrawn As Long
End Type

Private Declare Function DrawTextEx Lib "user32" Alias "DrawTextExA" (ByVal hDc As Long, ByVal lpsz As String, ByVal n As Long, lpRect As Rect, ByVal un As Long, lpDrawTextParams As DRAWTEXTPARAMS) As Long

Private udtRect As Rect
Private udtDrawText As DRAWTEXTPARAMS

' Properties
Private mvarText As String
Private mvarhDc As Long
Private mvarFlags As Long

'local variable(s) to hold property value(s)
Private mvarLeft As Long 'local copy
Private mvarRight As Long 'local copy
Private mvarTop As Long 'local copy
Private mvarBottom As Long 'local copy
Public Property Let Bottom(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Bottom = 5
    mvarBottom = vData
End Property


Public Property Get Bottom() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Bottom
    Bottom = mvarBottom
End Property



Public Property Let Top(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Top = 5
    mvarTop = vData
End Property


Public Property Get Top() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Top
    Top = mvarTop
End Property



Public Property Let Right(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Right = 5
    mvarRight = vData
End Property


Public Property Get Right() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Right
    Right = mvarRight
End Property



Public Property Let Left(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Left = 5
    mvarLeft = vData
End Property


Public Property Get Left() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Left
    Left = mvarLeft
End Property






Public Function DrawText() As Long

    With udtDrawText
        .cbSize = Len(udtDrawText)
        .uiLengthDrawn = Len(mvarText)
    End With
    
    With udtRect
        .Left = mvarLeft
        .Right = mvarRight
        .Top = mvarTop
        .Bottom = mvarBottom
    End With
    
    DrawText = DrawTextEx(mvarhDc, mvarText, Len(mvarText), udtRect, mvarFlags, udtDrawText)

End Function

Public Property Let Flags(lNewFlag As Long)
    mvarFlags = lNewFlag
End Property

Public Property Get Flags() As Long
    Flags = mvarFlags
End Property

Public Property Get hDc() As Long
    hDc = mvarhDc
End Property

Public Property Let hDc(lNewhDc As Long)
    mvarhDc = lNewhDc
End Property

Public Property Let Text(sNewVar As String)
    mvarText = sNewVar
End Property

Public Property Get Text() As String
    Text = mvarText
End Property

